Hooks:PostHook( WeaponFactoryTweakData, "init", "M16partsForGrenadierModInit", function(self)

	--overriding stance_mod when equipping the M16 barrel
	self.parts.wpn_fps_ass_kurisumasu_b_m16.override = {
		wpn_fps_ass_kurisumasu_gl_sight = {
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -28, -4.6),
					rotation = Rotation(0, 0, 0)
				}
			}	
		},
		wpn_fps_ass_kurisumasu_fg_car15 = {
			unit = "units/mods/weapons/wpn_fps_ass_kurisumasu_pts/wpn_fps_ass_kurisumasu_fg_m16a2"
		}
	}
	-- special case if combined with M5 handguard
	self.parts.wpn_fps_ass_kurisumasu_fg_kacm5.override = {
		wpn_fps_ass_kurisumasu_gl_sight = {
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -28, -4),
					rotation = Rotation(0, 0, 0)
				}
			}	
		},
		wpn_fps_ass_kurisumasu_gl_sight_base = {
			unit = "units/mods/weapons/wpn_fps_ass_kurisumasu_pts/wpn_fps_ass_kurisumasu_gl_sight_rail"
		}
	}
	-- setting up forbids
	if self.parts.wpn_fps_ass_kurisumasu_ur_m4.forbids then
		table.insert(self.parts.wpn_fps_ass_kurisumasu_ur_m4, "wpn_fps_ass_kurisumasu_o_rail_gooseneck")
	else
		self.parts.wpn_fps_ass_kurisumasu_ur_m4.forbids = {
			"wpn_fps_ass_kurisumasu_o_rail_gooseneck"
		}
	end
	if self.parts.wpn_fps_ass_kurisumasu_b_std.forbids then
		table.insert(self.parts.wpn_fps_ass_kurisumasu_b_std, "wpn_fps_ass_kurisumasu_fg_m203")
		table.insert(self.parts.wpn_fps_ass_kurisumasu_b_std, "wpn_fps_ass_kurisumasu_fg_kacm5")
	else
		self.parts.wpn_fps_ass_kurisumasu_b_std.forbids = {
			"wpn_fps_ass_kurisumasu_fg_m203",
			"wpn_fps_ass_kurisumasu_fg_kacm5"
		}
	end
	-- overriding the dummy optic rail
	self.parts.wpn_fps_ass_kurisumasu_ur_m16a1.override = {
		wpn_fps_ass_kurisumasu_ro_carry = {
			unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"
		},
		wpn_fps_ass_kurisumasu_o_rail_dummy = {
			unit = "units/mods/weapons/wpn_fps_ass_kurisumasu_pts/wpn_fps_ass_kurisumasu_o_rail",
			parent = "upper_reciever"
		},
		wpn_fps_upg_o_specter = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}	
		},
		wpn_fps_upg_o_aimpoint = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_docter = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_eotech = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_t1micro = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_acog = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_cmore = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_aimpoint_2 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_eotech_xps = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_reflex = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_rx01 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_rx30 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_cs = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_spot = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_bmg = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_uh = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_fc1 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_tf90 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_poe = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		}
	}
	-- M16A2 upper
	self.parts.wpn_fps_ass_kurisumasu_ur_m16a2.override = {
		wpn_fps_ass_kurisumasu_ro_carry = {
			unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"
		},
		wpn_fps_ass_kurisumasu_o_rail_dummy = {
			unit = "units/mods/weapons/wpn_fps_ass_kurisumasu_pts/wpn_fps_ass_kurisumasu_o_rail",
			parent = "upper_reciever"
		},
		wpn_fps_upg_o_specter = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}	
		},
		wpn_fps_upg_o_aimpoint = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_docter = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_eotech = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_t1micro = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_acog = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_cmore = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_aimpoint_2 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_eotech_xps = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_reflex = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_rx01 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_rx30 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_cs = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_spot = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_bmg = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_uh = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_fc1 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_tf90 = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_poe = {
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, 0, -5.08),
					rotation = Rotation(0, 0, 0)
				}
			}
		}
	}
	-- gooseneck mount
	self.parts.wpn_fps_ass_kurisumasu_o_rail_gooseneck.override = {
		wpn_fps_upg_o_specter = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}	
		},
		wpn_fps_upg_o_aimpoint = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_docter = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_eotech = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_t1micro = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_acog = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_cmore = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_aimpoint_2 = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_eotech_xps = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_reflex = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_rx01 = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_rx30 = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_cs = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_spot = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_bmg = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_uh = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_fc1 = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_tf90 = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		},
		wpn_fps_upg_o_poe = {
			a_obj = "a_o_gn",
			parent = "upper_reciever",
			stance_mod = {
				wpn_fps_ass_kurisumasu = {
					translation = Vector3(0, -2, -2),
					rotation = Rotation(0, 0, 0)
				}
			}
		}
	}
end )